###################################################
### chunk number 1: preliminaries
###################################################
library("aspect")
cleanup <- FALSE
options(prompt = "R> ", continue = "+  ")


###################################################
### chunk number 2: 
###################################################
require("aspect")
data("wurzer")
res.cor <- corAspect(wurzer, aspect = "aspectEigen", level = c(rep("nominal", 2), rep("ordinal", 5), "nominal"))


###################################################
### chunk number 3:  eval=FALSE
###################################################
## plot(res.cor, plot.type = "transplot", ylim = c(-3.5, 6))


###################################################
### chunk number 4: 
###################################################
res.smc <- corAspect(wurzer, aspect = "aspectSMC", level = c(rep("nominal", 2), rep("ordinal", 5), "nominal"), targvar = 2)


###################################################
### chunk number 5:  eval=FALSE
###################################################
## plot(res.smc, plot.type = "transplot", ylim = c(-4, 2))


###################################################
### chunk number 6: 
###################################################
myAspect <- function(r, a = 1, b = 1) list(a*b*r, matrix(a*b, nrow = nrow(r), ncol = ncol(r)))
res.my <- corAspect(wurzer, aspect = myAspect, a = 2, b = 4)


###################################################
### chunk number 7: 
###################################################
require("sem")
require("polycor")
data("duncan")
duncan.pc <- duncan[, 1:8]
head(duncan.pc)


###################################################
### chunk number 8: 
###################################################
dpc.polychor <- as.data.frame(apply(duncan.pc, 2, function(ccol) cut(ccol, c(0, 1, 2, 3, 4, 5))))
Rp <- hetcor(dpc.polychor, ML = TRUE)$correlations
round(Rp, 3)


###################################################
### chunk number 9: 
###################################################
res.lin <- lineals(duncan.pc, level = "ordinal")
Rl <- res.lin$cormat
round(Rl, 3)


###################################################
### chunk number 10:  eval=FALSE
###################################################
## plot(res.lin, plot.type = "regplot", plot.var = c(1, 2))
## plot(res.lin, plot.type = "regplot", plot.var = c(1, 5))
## plot(res.lin, plot.type = "regplot", plot.var = c(5, 6))


###################################################
### chunk number 11: 
###################################################
dpc.ram <- specify.model(textConnection("
POT -> POT_T1, NA, 1
POT -> POT_T2, lam12, NA
POT -> POT_T3, lam13, NA
POT -> POT_T4, lam14, NA
CIG -> CIG_T1, NA, 1
CIG -> CIG_T2, lam22, NA
CIG -> CIG_T3, lam23, NA
CIG -> CIG_T4, lam24, NA
POT_T1 <-> POT_T1, th11, NA
POT_T2 <-> POT_T2, th12, NA
POT_T3 <-> POT_T3, th13, NA
POT_T4 <-> POT_T4, th14, NA
CIG_T1 <-> CIG_T1, th21, NA
CIG_T2 <-> CIG_T2, th22, NA
CIG_T3 <-> CIG_T3, th23, NA
CIG_T4 <-> CIG_T4, th24, NA
POT <-> POT, phi1, NA
CIG <-> CIG, phi2, NA
POT <-> CIG, rho1, NA
"))


###################################################
### chunk number 12: 
###################################################
sem.pol <- sem(dpc.ram, Rp, N = 1204)
sem.lin <- sem(dpc.ram, Rl, N = 1204)


